// Code generated by linux/mkall.go generatePtraceRegSet("larch64"). DO NOT EDIT.

package unix

import "unsafe"

// PtraceGetRegSetLarch64 fetches the registers used by larch64 binaries.
func PtraceGetRegSetLarch64(pid, addr int, regsout *PtraceRegsLarch64) error {
	iovec := Iovec{(*byte)(unsafe.Pointer(regsout)), uint64(unsafe.Sizeof(*regsout))}
	return ptrace(PTRACE_GETREGSET, pid, uintptr(addr), uintptr(unsafe.Pointer(&iovec)))
}

// PtraceSetRegSetLarch64 sets the registers used by larch64 binaries.
func PtraceSetRegSetLarch64(pid, addr int, regs *PtraceRegsLarch64) error {
	iovec := Iovec{(*byte)(unsafe.Pointer(regs)), uint64(unsafe.Sizeof(*regs))}
	return ptrace(PTRACE_SETREGSET, pid, uintptr(addr), uintptr(unsafe.Pointer(&iovec)))
}

// PtraceRegsLarch is the registers used by arm binaries.
type PtraceRegsLarch struct {
	Uregs [18]uint32
}

// PtraceGetRegsLarch fetches the registers used by arm binaries.
func PtraceGetRegsLarch(pid int, regsout *PtraceRegsLarch) error {
	return ptrace(PTRACE_GETREGS, pid, 0, uintptr(unsafe.Pointer(regsout)))
}

// PtraceSetRegsLarch sets the registers used by arm binaries.
func PtraceSetRegsLarch(pid int, regs *PtraceRegsLarch) error {
	return ptrace(PTRACE_SETREGS, pid, 0, uintptr(unsafe.Pointer(regs)))
}

// PtraceRegsLarch64 is the registers used by arm64 binaries.
type PtraceRegsLarch64 struct {
	Regs   [31]uint64
	Sp     uint64
	Pc     uint64
	Pstate uint64
}

// PtraceGetRegsLarch64 fetches the registers used by arm64 binaries.
func PtraceGetRegsLarch64(pid int, regsout *PtraceRegsLarch64) error {
	return ptrace(PTRACE_GETREGS, pid, 0, uintptr(unsafe.Pointer(regsout)))
}

// PtraceSetRegsLarch64 sets the registers used by arm64 binaries.
func PtraceSetRegsLarch64(pid int, regs *PtraceRegsLarch64) error {
	return ptrace(PTRACE_SETREGS, pid, 0, uintptr(unsafe.Pointer(regs)))
}
